﻿//=======================================
//  Javascript to apply dark frame calibration
//   dark frame is opened
//   then subtracted from the light frame(s)
//   dark frame is then closed
//
//  Notes
//  
//=======================================
#include Functions\our_subtractImage.jsxinc
#include Functions\call_javascript_menu.jsxinc
//=======================================

var ourPerCent = 100.000000;
var tiffOptions = new TiffSaveOptions();
tiffOptions.Layers = true;

var firstTime = "Y";

//call_javascript ("D:\\Astro_PJ_Distribution\\OpenDSLRRawBin.jsxbin");
call_javascript_menu ("OpenDSLRRawBin");

//number of documents
var documentsOpen = app.documents.length;

//when open the active document is the dark
var nDark = activeDocument.name;

for (var i = 0; i<documentsOpen; i++) {

        app.activeDocument = documents[i];
        if (activeDocument.name != nDark) { //ignore dark frame from processing
          //Subtract Dark frame
          // function with return value
          retPerCent = ourSubtractImage (nDark, ourPerCent, "N"); //supress dialogs
          if (firstTime == "Y") {
           ourPerCent = retPerCent;
          }
          var myDocName = activeDocument.name;
          var outputName = myDocName.substring(0,myDocName.length - 4);
          //app.activeDocument.saveAs(new File (activeDocument.path + "/DC" + outputName + ".tif"), tiffOptions );
          firstTime = "N";
        }
}
//remove Dark CR2
documents.getByName(nDark).close(SaveOptions.DONOTSAVECHANGES);



