﻿//=======================================
//  Javascript to remove a gradient
//  image is copied
//  copy image has a gussian blur of 200
//  Histograms for each channel are received
//   When value is greater than 0, this is set as the black point
//  on original image the copied image is subtracted
//
//  Notes
//  
//=======================================
#include Functions\set_blackpoint.jsxinc
#include Functions\our_subtractImage.jsxinc
#include Functions\our_gaussBlur.jsxinc
//=======================================

var ourPixelSize = 200.000000;
var retPixelSize = 200.000000;
var ourPerCent = 100.000000;
var retPerCent = 100.000000;
var myDoc;

var tiffOptions = new TiffSaveOptions();
tiffOptions.Layers = true;

//number of documents
var documentsOpen = app.documents.length;

var dlg=  
"dialog{text:'Remove Gradient',bounds:[100,100,500,220],"+  
"statictext0:StaticText{bounds:[10,10,240,27] , text:'Do you want to adjust the settings' ,properties:{scrolling:undefined,multiline:undefined}},"+  
"button1:Button{bounds:[10,80,190,101] , text:'YES' },"+  
"button2:Button{bounds:[210,80,390,101] , text:'NO' }};"  
var win = new Window(dlg,'Gradient removal');  
win.center();  
win.button1.onClick = function() {
    cSwitch = "Y";
    win.close(1);
}  
win.button2.onClick = function() {
    cSwitch = "N";
    win.close(1);
}
win.show(); 

var firstTime = "Y";

if (cSwitch == "N") {
  firstTime = "N"; 
}

// Process
    for (var i = 0; i<documentsOpen; i++) {
      
        app.activeDocument = documents[i];

        //Duplicate Active document
        app.activeDocument.duplicate ("WorkArea");

        //store document name
        var myDocCopy = app.activeDocument;

        //function with return value
        retPixelSize = ourGaussBlur (ourPixelSize, firstTime); 
        if (firstTime == "Y") {
           ourPixelSize = retPixelSize;
        }



        //darken image here
        var rStart = 0;
        var bStart = 0;
        var gStart = 0;

        var channelRef = documents[i].channels.getByName("Red");
        var cStates = channelRef.histogram;
        for (j=0; j<256; j++) {
        if (cStates[j] > 0) {
         if (rStart == 0) {
          rStart = j; } } }
        setBlackPoint ("Red", rStart);

        var channelRef = documents[i].channels.getByName("Blue");
        var cStates = channelRef.histogram;
        for (j=0; j<256; j++) {
        if (cStates[j] > 0) {
        if (bStart == 0) {
          bStart = j; } } }
        setBlackPoint ("Blue", bStart);

        var channelRef = documents[i].channels.getByName("Green");
        var cStates = channelRef.histogram;
        for (j=0; j<256; j++) {
        if (cStates[j] > 0) {
        if (gStart == 0) {
          gStart = j; } } }
        setBlackPoint ("Green", gStart); 


        //return to original image
        app.activeDocument = documents[i];
 
        // function with return value
        retPerCent = ourSubtractImage ("WorkArea", ourPerCent, firstTime); 
        if (firstTime == "Y") {
           ourPerCent = retPerCent;
        }

        //Deselect 
        activeDocument.selection.deselect();
      
        var myDocName = activeDocument.name;
        var outputName = myDocName.substring(0,myDocName.length - 4);
        // app.activeDocument.saveAs(new File (activeDocument.path + "/RG" + outputName + ".tif"), tiffOptions );

        myDocCopy.close(SaveOptions.DONOTSAVECHANGES);
        firstTime = "N";
    }

alert ("Process completed");


