﻿//=======================================
//  Javascript to remove a gradient
//  image is copied
//  copy image has a gussian blur of 200
//  Histograms for each channel are received
//   When value is greater than 0, this is set as the black point
//  on original image the copied image is subtracted
//
//  Notes Functions are included for Dave Eagle
//
//  


var ourPixelSize = 200.000000;
var retPixelSize = 200.000000;
var ourPerCent = 100.000000;
var retPerCent = 100.000000;
var myDoc;


//number of documents
var documentsOpen = app.documents.length;

var dlg=  
"dialog{text:'Remove Gradient',bounds:[100,100,500,220],"+  
"statictext0:StaticText{bounds:[10,10,240,27] , text:'Do you want to adjust the settings' ,properties:{scrolling:undefined,multiline:undefined}},"+  
"button1:Button{bounds:[10,80,190,101] , text:'YES' },"+  
"button2:Button{bounds:[210,80,390,101] , text:'NO' }};"  
var win = new Window(dlg,'Gradient removal');  
win.center();  
win.button1.onClick = function() {
    cSwitch = "Y";
    win.close(1);
}  
win.button2.onClick = function() {
    cSwitch = "N";
    win.close(1);
}
win.show(); 

var firstTime = "Y";

if (cSwitch == "N") {
  firstTime = "N"; 
}

// Process
    for (var i = 0; i<documentsOpen; i++) {
      
        app.activeDocument = documents[i];

        //Duplicate Active document
        app.activeDocument.duplicate ("WorkArea");

        //store document name
        var myDocCopy = app.activeDocument;

        //function with return value
        retPixelSize = ourGaussBlur (ourPixelSize, firstTime); 
        if (firstTime == "Y") {
           ourPixelSize = retPixelSize;
        }



        //darken image here
        var rStart = 0;
        var bStart = 0;
        var gStart = 0;

        var channelRef = documents[i].channels.getByName("Red");
        var cStates = channelRef.histogram;
        for (j=0; j<256; j++) {
        if (cStates[j] > 0) {
         if (rStart == 0) {
          rStart = j; } } }
        setBlackPoint ("Red", rStart);

        var channelRef = documents[i].channels.getByName("Blue");
        var cStates = channelRef.histogram;
        for (j=0; j<256; j++) {
        if (cStates[j] > 0) {
        if (bStart == 0) {
          bStart = j; } } }
        setBlackPoint ("Blue", bStart);

        var channelRef = documents[i].channels.getByName("Green");
        var cStates = channelRef.histogram;
        for (j=0; j<256; j++) {
        if (cStates[j] > 0) {
        if (gStart == 0) {
          gStart = j; } } }
        setBlackPoint ("Green", gStart); 


        //return to original image
        app.activeDocument = documents[i];
 
        // function with return value
        retPerCent = ourSubtractImage ("WorkArea", ourPerCent, firstTime); 
        if (firstTime == "Y") {
           ourPerCent = retPerCent;
        }

        //Deselect 
        activeDocument.selection.deselect();

        myDocCopy.close(SaveOptions.DONOTSAVECHANGES);
        firstTime = "N";
    }

alert ("Process completed");

//=======================================
//#include Functions\set_blackpoint.jsxinc


function setBlackPoint( ourColor, ourLevel) {

// =======================================================
var idLvls = charIDToTypeID( "Lvls" );
    var desc5 = new ActionDescriptor();
    var idpresetKind = stringIDToTypeID( "presetKind" );
    var idpresetKindType = stringIDToTypeID( "presetKindType" );
    var idpresetKindCustom = stringIDToTypeID( "presetKindCustom" );
    desc5.putEnumerated( idpresetKind, idpresetKindType, idpresetKindCustom );
    var idAdjs = charIDToTypeID( "Adjs" );
        var list1 = new ActionList();
            var desc6 = new ActionDescriptor();
            var idChnl = charIDToTypeID( "Chnl" );
                var ref1 = new ActionReference();
                var idChnl = charIDToTypeID( "Chnl" );
                var idChnl = charIDToTypeID( "Chnl" );
                if (ourColor == "Blue") {
                 var idBl = charIDToTypeID( "Bl  " );
                 ref1.putEnumerated( idChnl, idChnl, idBl );
                }
                if (ourColor == "Green") {
                 var idGrn = charIDToTypeID( "Grn " );
                 ref1.putEnumerated( idChnl, idChnl, idGrn );
                }
                if (ourColor == "Red") {
                 var idRd = charIDToTypeID( "Rd  " );
                 ref1.putEnumerated( idChnl, idChnl, idRd );
                }
                if (ourColor == "RGB") {
                 var idCmps = charIDToTypeID( "Cmps" );
                 ref1.putEnumerated( idChnl, idChnl, idCmps );
                }
            desc6.putReference( idChnl, ref1 );
            var idInpt = charIDToTypeID( "Inpt" );
                var list2 = new ActionList();
                list2.putInteger( ourLevel );
                list2.putInteger( 255 );
            desc6.putList( idInpt, list2 );
        var idLvlA = charIDToTypeID( "LvlA" );
        list1.putObject( idLvlA, desc6 );
    desc5.putList( idAdjs, list1 );
executeAction( idLvls, desc5, DialogModes.NO );
}


//=======================================
//#include Functions\our_subtractImage.jsxinc

function ourSubtractImage (ourImage, ourPerCent, ourMode) {
// =======================================================
// usage
// retPerCent = ourApplyImage (string imagenamme, double percent, string firstTime);
// returns
// applied percent
// =======================================================
var idAppI = charIDToTypeID( "AppI" );
var desc10 = new ActionDescriptor();
var idWith = charIDToTypeID( "With" );
var desc11 = new ActionDescriptor();
var idT = charIDToTypeID( "T   " );
var ref2 = new ActionReference();
var idChnl = charIDToTypeID( "Chnl" );
var idChnl = charIDToTypeID( "Chnl" );
var idRGB = charIDToTypeID( "RGB " );
ref2.putEnumerated( idChnl, idChnl, idRGB );
var idLyr = charIDToTypeID( "Lyr " );
var idBckg = charIDToTypeID( "Bckg" );
ref2.putProperty( idLyr, idBckg );
var idDcmn = charIDToTypeID( "Dcmn" );
ref2.putName( idDcmn, ourImage );
desc11.putReference( idT, ref2 );
var idClcl = charIDToTypeID( "Clcl" );
var idClcn = charIDToTypeID( "Clcn" );
var idSbtr = charIDToTypeID( "Sbtr" );
desc11.putEnumerated( idClcl, idClcn, idSbtr );
var idScl = charIDToTypeID( "Scl " );
desc11.putDouble( idScl, 1.000000 );
var idOfst = charIDToTypeID( "Ofst" );
desc11.putInteger( idOfst, 0);
var idOpct = charIDToTypeID( "Opct" );
var idPrc = charIDToTypeID( "#Prc" );
desc11.putUnitDouble( idOpct, idPrc, ourPerCent );
var idPrsT = charIDToTypeID( "PrsT" );
desc11.putBoolean( idPrsT, true );
var idClcl = charIDToTypeID( "Clcl" );
desc10.putObject( idWith, idClcl, desc11 );
var dMode;
if (ourMode == "Y") {
  dMode = DialogModes.ALL; }
else {
  dMode = DialogModes.NO; }

var iappDesc = app.executeAction( idAppI, desc10, dMode );

if (iappDesc.getObjectValue(idWith).hasKey(idOpct)) {
    retPerCent = iappDesc.getObjectValue(idWith).getUnitDoubleValue(idOpct);
} else {
    retPerCent = ourPerCent; }
return retPerCent;
}

//=======================================
//#include Functions\our_gaussBlur.jsxinc

function ourGaussBlur (ourBlurPixel, ourMode) {
// =======================================================
// usage
// retBlurPixel = ourGaussBlur (int ourBlurPixel, string firstTime);
// returns selected pixel size
// =======================================================
var idGsnB = charIDToTypeID( "GsnB" );
var desc5 = new ActionDescriptor();
var idRds = charIDToTypeID( "Rds " );
var idPxl = charIDToTypeID( "#Pxl" );
desc5.putUnitDouble( idRds, idPxl, ourBlurPixel );
var dMode;
if (ourMode == "Y") {
  dMode = DialogModes.ALL; }
else {
  dMode = DialogModes.NO; }

var blurDesc = app.executeAction( idGsnB, desc5, dMode );
if (blurDesc.hasKey(idRds)) {
    retBlurPixel = blurDesc.getUnitDoubleValue(idRds);
} else {
    retBlurPixel = ourBlurPixel; }
return retBlurPixel;
}


//=======================================
