﻿//=======================================
//  Javascript to process
//   Run the Javascript OpenDSLRRaw
//   Run the Javascript ApplyDarkCorrection (if require)
//   Run the Javascript SetBlackPoint (if required)
//   Run the Javascript ApplyLensCorrection (if required)
//   Save all open files as TIFF files as CAL_....
//=======================================

#include Functions\call_javascript_menu.jsxinc

//=======================================

var firstTime = "Y";

var tiffOptions = new TiffSaveOptions();
tiffOptions.Layers = true;
alert ("You will be prompted to select your light (CR2) files");

call_javascript_menu ("OpenDSLRRawBin");

var dlg=  
"dialog{text:'Basic Process',bounds:[100,100,500,220],"+  
"statictext0:StaticText{bounds:[10,10,240,27] , text:'Do you want to subtract a dark frame' ,properties:{scrolling:undefined,multiline:undefined}},"+  
"button1:Button{bounds:[10,80,190,101] , text:'YES' },"+  
"button2:Button{bounds:[210,80,390,101] , text:'NO' }};"  
var win = new Window(dlg,'test');  
win.center();  
win.button1.onClick = function() {
    cSwitch = "Y";
    win.close(1);
}  
win.button2.onClick = function() {
    cSwitch = "N";
    win.close(1);
}
win.show(); 
var bStart = 0;
if (cSwitch == "Y") {
   // call Dark correction
    alert ("You will be prompted to select your dark frame");
    
    call_javascript_menu ("ApplyDarkCorrectionBin");

    firstTime = "N"; 

}
//=======================================
//=======================================
var dlg=  
"dialog{text:'Basic Process',bounds:[100,100,500,220],"+  
"statictext0:StaticText{bounds:[10,10,240,27] , text:'Do you want to remove vignetting' ,properties:{scrolling:undefined,multiline:undefined}},"+  
"button1:Button{bounds:[10,80,190,101] , text:'YES' },"+  
"button2:Button{bounds:[210,80,390,101] , text:'NO' }};"  
var win = new Window(dlg,'test');  
win.center();  
win.button1.onClick = function() {
    cSwitch = "Y";
    win.close(1);
}  
win.button2.onClick = function() {
    cSwitch = "N";
    win.close(1);
}
win.show(); 
var bStart = 0;
if (cSwitch == "Y") {
   // call ApplyLensCorrection
   
   call_javascript_menu ("ApplyLensCorrectionBin");

    firstTime = "N"; 

}
//=======================================

//=======================================
var dlg=  
"dialog{text:'Basic Process',bounds:[100,100,500,220],"+  
"statictext0:StaticText{bounds:[10,10,240,27] , text:'Do you want to set black point' ,properties:{scrolling:undefined,multiline:undefined}},"+  
"button1:Button{bounds:[10,80,190,101] , text:'YES' },"+  
"button2:Button{bounds:[210,80,390,101] , text:'NO' }};"  
var win = new Window(dlg,'test');  
win.center();  
win.button1.onClick = function() {
    cSwitch = "Y";
    win.close(1);
}  
win.button2.onClick = function() {
    cSwitch = "N";
    win.close(1);
}
win.show(); 
var bStart = 0;
if (cSwitch == "Y") {
   // call SetBlackPoint
   
   call_javascript_menu ("SetBlackPointBin");
   
    firstTime = "N"; 

}
//=======================================

//=======================================
var dlg=  
"dialog{text:'Basic Process',bounds:[100,100,500,220],"+  
"statictext0:StaticText{bounds:[10,10,240,27] , text:'Do you want to remove gradient' ,properties:{scrolling:undefined,multiline:undefined}},"+  
"button1:Button{bounds:[10,80,190,101] , text:'YES' },"+  
"button2:Button{bounds:[210,80,390,101] , text:'NO' }};"  
var win = new Window(dlg,'test');  
win.center();  
win.button1.onClick = function() {
    cSwitch = "Y";
    win.close(1);
}  
win.button2.onClick = function() {
    cSwitch = "N";
    win.close(1);
}
win.show(); 

var bStart = 0;
if (cSwitch == "Y") {
   // call remove gradient

   call_javascript_menu ("ApplyGradientRemovalBin");

    firstTime = "N"; 

}
//=======================================


//=======================================

for (var i = 0; i < documents.length; i++) {	//loop with index(i) to point to each open document
        activeDocument = documents[i];          //same as selecting with the mouse
        var myDocName = activeDocument.name;
        var outputName = myDocName.substring(0,myDocName.length - 4);
        app.activeDocument.saveAs(new File (activeDocument.path + "/CAL_" + outputName + ".tif"), tiffOptions );

}

alert ("Images open ready for stacking");
